TIME_TO_WINTER = 60*80

function CreateQuestWinter()

	wintercounterjob = StartSimpleJob("QuestWinter")
	winterChangeJob = Trigger.RequestTrigger(Events.LOGIC_EVENT_WEATHER_STATE_CHANGED,nil,"WinterOnTower",1,nil,nil)
	
	function GUIAction_ChangeWeather(_weathertype)
	
		--Ansu: add texkey here!
		if Logic.IsWeatherChangeActive() == true then
			GUI.AddNote(XGUIEng.GetStringTableText("InGameMessages/Note_WeatherIsCurrentlyChanging"))		
			return
		end
		
		local PlayerID = GUI.GetPlayerID()
		local CurrentWeatherEnergy = Logic.GetPlayersGlobalResource( PlayerID, ResourceType.WeatherEnergy )	
		local NeededWeatherEnergy = Logic.GetEnergyRequiredForWeatherChange()
		
		if CurrentWeatherEnergy >= NeededWeatherEnergy then		
			GUI.AddNote(XGUIEng.GetStringTableText("InGameMessages/GUI_WeathermashineActivated"))		
			GUI.SetWeather(_weathertype)
			
		else
			GUI.AddNote(XGUIEng.GetStringTableText("InGameMessages/GUI_WeathermashineNotReady"))
		end
		
	end

end

function WinterOnTower()
	if Event.GetNewWeatherState() == 3 then
		EndJob(wintercounterjob)
		if not IsBriefingActive() and not IsCutsceneActive() and not Logic.IsWeatherChangeActive() then
			StartWinter(10000000)
			
			MapLocal_StopCountDown(0)
			
			end3rdChapter()
		else
			StartSimpleJob("WinterDelayerJob")
		end
		return true
	end
	return false
end

function WinterDelayerJob()
	if not IsBriefingActive() and not IsCutsceneActive() and not Logic.IsWeatherChangeActive() then
		StartWinter(10000000)
				
		MapLocal_StopCountDown(0)
				
		end3rdChapter()
		return true
	end
	return false
end

function QuestWinter()

	
	if countDownStarted ~= true then
	
		-- Show timer
		MapLocal_StartCountDown(TIME_TO_WINTER)

		countDownStarted = true

	end

	if WinterTimeGone == true then

		if not IsBriefingActive() and not IsCutsceneActive() and not Logic.IsWeatherChangeActive() then
			EndJob(winterChangeJob)
			StartWinter(10000000)
			
			MapLocal_StopCountDown(TIME_TO_WINTER)
			
			end3rdChapter()
			
			return true
	
		end
		
	end

	if Counter.Tick2("QuestWinter", TIME_TO_WINTER) then

		WinterTimeGone = true
			
	end

end

function WetterTurmEinfrieren()
	Message("@color:0,204,255 Wettertürme sind durch den Wintereinbruch vereißt worden. Sie sind nicht mehr benutzbar!")
	GameCallback_OnBuildingConstructionCompleteOld=GameCallback_OnBuildingConstructionComplete
	function GameCallback_OnBuildingConstructionComplete(_BuildingID,_PlayerID)
		GameCallback_OnBuildingConstructionCompleteOld(_BuildingID,_PlayerID)
			if Logic.GetEntityType(_BuildingID) == Entities.PB_WeatherTower1 then
				Logic.SetEntitySelectableFlag(_BuildingID, 0)
			end
	end
	local n, first = Logic.GetPlayerEntities(1, Entities.PB_WeatherTower1, 1);
    if n > 0 then
        local entity = first;
        repeat
			Logic.SetEntitySelectableFlag(entity, 0)
			entity = Logic.GetNextEntityOfPlayerOfType(entity);
        until entity == first;
    end;
end